%define anolis_release 2
%define kpatch_dnf_ver	0.4

Name:		kpatch
Version:	0.9.4
Release:	%{anolis_release}%{?dist}
Summary:	Dynamic kernel patch manager

Group:		System Environment/Kernel
License:	GPLv2
URL:		https://github.com/dynup/kpatch
Source0:	https://github.com/dynup/kpatch/archive/v%{version}.tar.gz
Source1:	kpatch-dnf-v%{kpatch_dnf_ver}.tar.gz

Patch0:		0001-contrib-disable-upstart-kpatch.conf-install.patch
Patch1:		0002-kpatch-clarify-unload-unsupport.patch
Patch2:		0003-do-not-rm-selinux-rpm-owned-directory.patch
Patch3:         0004-remove-confirm-prompt-when-unloading-patches.patch

Requires:	bash kmod binutils
Recommends:	kpatch-dnf

BuildArch:	noarch


%description
kpatch is a live kernel patch module manager.  It allows the user to manage
a collection of binary kernel patch modules which can be used to dynamically
patch the kernel without rebooting.

%package -n kpatch-dnf
Summary:	kpatch-patch manager plugin for DNF
Version:	%kpatch_dnf_ver
BuildRequires:	python3-devel python3-dnf
Requires:	python3-dnf python3-hawkey
Provides:	kpatch-dnf

%description -n kpatch-dnf
kpatch-dnf is a DNF plugin that manages subscription to kpatch-patch updates.
When enabled, kernel packages are automatically subscribed to corresponding
kpatch-patch packages updates.

%prep
%autosetup -n %{name}-0.9.4 -p1 -a 1
cd kpatch-dnf-%{kpatch_dnf_ver}
cd ..

%build
make -C man

make -C kpatch-dnf-%{kpatch_dnf_ver}

%install
make install PREFIX=/usr DESTDIR=%{buildroot} -C kpatch
make install PREFIX=/usr DESTDIR=%{buildroot} -C man
make install PREFIX=/usr DESTDIR=%{buildroot} -C contrib
mkdir -p %{buildroot}/%{_sharedstatedir}/kpatch
rm -f %{buildroot}/usr/share/man/man1/kpatch-build.1.zst

make install PREFIX=/usr DESTDIR=%{buildroot} PYTHONSITES=%{python3_sitelib} -C kpatch-dnf-%{kpatch_dnf_ver}

%files
%{_sbindir}/kpatch
%{_usr}/lib/systemd/system/kpatch.service
%{_sharedstatedir}/kpatch
%{_mandir}/man1/kpatch.1.zst
%exclude %{_mandir}/man1/kpatch-build.1.zst

%files -n kpatch-dnf
%config(noreplace) %{_sysconfdir}/dnf/plugins/kpatch.conf
%{python3_sitelib}/dnf-plugins/kpatch.py
%{python3_sitelib}/dnf-plugins/__pycache__
%{_mandir}/man8/dnf.kpatch.8.zst

%post -n kpatch-dnf
echo "To enable automatic kpatch-patch subscription, run:"
echo -e "\t$ dnf kpatch auto"

%changelog
* Tue Mar 12 2024 Bo Ren <rb01097748@alibaba-inc.com> - 0.9.4-2
- Rebuild with python3.11

* Tue Apr 11 2023 happy_orange <songnannan@linux.alibaba.com> - 0.9.4-1
- init package
